//
//  WriteReviewViewController.m
//  iAppsReview
//
//  Created by Kevin McNeish on 5/29/13.
//  Copyright (c) 2013 Oak Leaf Enterprises, Inc. All rights reserved.
//

#import "WriteReviewViewController.h"
#import <CoreData/CoreData.h>

@interface WriteReviewViewController ()

@end

@implementation WriteReviewViewController {
	UIImage *image;
	NSURL *imageURL;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
	self.starRating.delegate = self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)shareReview:(id)sender {

	NSString *reviewText = self.tvwReview.text;
	NSString *appName = self.txtAppName.text;

	NSString *fullReviewText = [appName stringByAppendingFormat:@" - %@",reviewText];

	NSArray *activityItems = [NSArray arrayWithObjects:fullReviewText, nil];
	UIActivityViewController *avc = [[UIActivityViewController alloc]
									 initWithActivityItems:activityItems
									 applicationActivities:nil];
	[self presentViewController:avc animated:YES completion:nil];
}

- (IBAction)accessPhotoLibrary:(id)sender {

	// Create the image picker controller
	UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];

	// Set the image picker controller properties
	imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;

	// Store a reference to the view controller in the delegate property
	imagePicker.delegate = self;

	// Display the image picker controller
	[self presentViewController:imagePicker animated:YES completion:nil];
}

- (IBAction)appNameChanged:(id)sender {

	self.btnShare.enabled = [self isReadyToShare];
}

- (void)textViewDidChange:(UITextView *)textView {

	self.btnShare.enabled = [self isReadyToShare];
}

- (void)starRating:(mmStarRating *)starRating ratingDidChange:(float)rating {
	
	self.btnShare.enabled = [self isReadyToShare];
}

- (BOOL)isReadyToShare {
	// Check if either the text view or the text field is empty
	if (self.tvwReview.text.length == 0 || self.txtAppName.text.length == 0 ||
		self.starRating.rating == 0) {
		// One or both of them is empty, disable the button
		return NO;
	}
	else {
		// Neither control is empty, enable the button
		return YES;
	}
}

- (void)imagePickerController:(UIImagePickerController *)
picker didFinishPickingMediaWithInfo:(NSDictionary *)info
{
	[self dismissViewControllerAnimated:YES completion:nil];

	// Get the image and store it in the image view
	image = info[UIImagePickerControllerOriginalImage];
	self.imgThumbNail.image = image;

	// Get the URL of the image
	imageURL = info[UIImagePickerControllerReferenceURL];
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
	[self dismissViewControllerAnimated:YES completion:nil];
}

@end
